/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************

    Module Name:
    rbus_main_dev.c

    Abstract:
    Create and register network interface for RBUS based chipsets in linux platform.

    Revision History:
    Who         When            What
    --------    ----------      ----------------------------------------------
*/
#define RTMP_MODULE_OS

#include "rt_config.h"


static struct net_device *rt2880_dev = NULL;


VOID __exit rt2880_module_exit(VOID);
int __init rt2880_module_init(VOID);

static unsigned int MAC_ADDR[6];
static int mac_len;

unsigned int mac_addr_6[6];
int mac_len_6;

module_param_array(MAC_ADDR, uint, &mac_len, 0400);
MODULE_PARM_DESC(MAC_ADDR, "MAC_ADDR");

module_init(rt2880_module_init);
module_exit(rt2880_module_exit);

#if defined(CONFIG_RA_CLASSIFIER)&&(!defined(CONFIG_RA_CLASSIFIER_MODULE)) 	 
extern int (*ra_classifier_init_func) (void) ; 	 
extern void (*ra_classifier_release_func) (void) ; 	 
extern struct proc_dir_entry *proc_ptr, *proc_ralink_wl_video;	 
#endif

//steven add for client list read
ssize_t sta_list_read(char *page, char **start, off_t off,
                int count, int *eof, void *data)
{
        struct net_device   *net_dev = rt2880_dev;
        RTMP_ADAPTER *pAd = net_dev->priv;
        int i;
        ssize_t len=0;

        if (pAd != NULL)
        {
                if (off > 0)
                {
                        *eof = 1;
                        return 0;
                }

                //printk("MAX_LEN_OF_MAC_TABLE=%d size=%d\n", MAX_LEN_OF_MAC_TABLE, pAd->MacTab.Size);

                for (i=0; i<MAX_LEN_OF_MAC_TABLE; i++)
                {
                        PMAC_TABLE_ENTRY pEntry = &pAd->MacTab.Content[i];

                        //printk("SST=%d \n",pEntry->Sst);

                        if( (IS_ENTRY_CLIENT(pEntry)) && (pEntry->Sst==SST_ASSOC))
                        {
                                //printk("%d : %02X%02X%02X%02X%02X%02X\n",i,pEntry->Addr[0], pEntry->Addr[1], pEntry->Addr[2],pEntry->Addr[3], pEntry->Addr[4], pEntry->Addr[5]);
                                len += sprintf(page+len, "%02X%02X%02X%02X%02X%02X\n",pEntry->Addr[0], pEntry->Addr[1], pEntry->Addr[2],pEntry->Addr[3], pEntry->Addr[4], pEntry->Addr[5]);
                        }
                }
        }
	else
                printk("pAd == NULL\n");
    return len;
}

#if defined (AP_SCAN_SUPPORT) || defined (CONFIG_STA_SUPPORT)
#define LINE_LEN        (4+33+20+23+9+7+3)      // Channel+SSID+Bssid+Security+Signal+WiressMode+NetworkType
#ifdef CONFIG_STA_SUPPORT
#ifdef WSC_STA_SUPPORT
#define WPS_LINE_LEN    (4+5)   // WPS+DPID
#endif // WSC_STA_SUPPORT //
#endif // CONFIG_STA_SUPPORT //
#ifdef DOT11R_FT_SUPPORT
#define DOT11R_LINE_LEN	(5+9+10)	// MDId+FToverDS+RsrReqCap
#endif // DOT11R_FT_SUPPORT //
static int scanap_list_read(char *page, char **start, off_t off,
                int count, int *eof, void *data)
{
	struct net_device   *net_dev = rt2880_dev;
      	RTMP_ADAPTER *pAd = net_dev->priv;
     	PRTMP_ADAPTER   pAdapter = data;
    	INT max_len = LINE_LEN;
        PBSS_ENTRY      pBss;
	INT         Rssi = 0;
        UINT        Rssi_Quality = 0;
        NDIS_802_11_NETWORK_TYPE    wireless_mode;
        CHAR            Ssid[MAX_LEN_OF_SSID +1];
        STRING          SecurityStr1[32] = {0},SecurityStr2[32] = {0};
        NDIS_802_11_ENCRYPTION_STATUS   ap_cipher = Ndis802_11EncryptionDisabled;
        NDIS_802_11_AUTHENTICATION_MODE ap_auth_mode = Ndis802_11AuthModeOpen;

	int i;
        ssize_t len=0;

#ifdef CONFIG_STA_SUPPORT
#ifdef WSC_STA_SUPPORT
        max_len += WPS_LINE_LEN;
#endif // WSC_STA_SUPPORT //
#endif // CONFIG_STA_SUPPORT //
#ifdef DOT11R_FT_SUPPORT
	max_len += DOT11R_LINE_LEN;
#endif // DOT11R_FT_SUPPORT //
	if (pAd != NULL)
        {
        	if (off > 0)
          	{
               		*eof = 1;
                   	return 0;
         	}
		for(i=0; i<pAdapter->ScanTab.BssNr ;i++)
        	{
                	pBss = &pAdapter->ScanTab.BssEntry[i];

                	if( pBss->Channel==0)
                        	break;

                	if((len+max_len ) >= IW_SCAN_MAX_DATA)
                        	break;
                	//SSID
			NdisZeroMemory(Ssid, (MAX_LEN_OF_SSID +1));
			if (RTMPCheckStrPrintAble((PCHAR)pBss->Ssid, pBss->SsidLen))
				NdisMoveMemory(Ssid, pBss->Ssid, pBss->SsidLen);
			else
			{
				INT idx = 0;
				for (idx = 0; idx < 16; idx++)
					sprintf(Ssid, "%s%02X", Ssid, pBss->Ssid[idx]);
			}
                	len+=sprintf(page+len,"%s\n", Ssid);
        		//Security
        		if ((Ndis802_11AuthModeWPA <= pBss->AuthMode) &&
                		(pBss->AuthMode <= Ndis802_11AuthModeWPA1PSKWPA2PSK))
        		{
				if (pBss->AuthModeAux == Ndis802_11AuthModeWPANone)
                		{
                        		ap_auth_mode = pBss->AuthMode;
                        		if (pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled)
                                		ap_cipher = pBss->WPA.PairCipher;
                        		else
                               		 	ap_cipher = Ndis802_11Encryption4Enabled;
                		}
                		else if (pBss->AuthModeAux == Ndis802_11AuthModeOpen)
                		{
                        		ap_auth_mode = pBss->AuthMode;
                        		if ((ap_auth_mode == Ndis802_11AuthModeWPA) ||
                                		(ap_auth_mode == Ndis802_11AuthModeWPAPSK))
                        		{
                                		if (pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled)
                                        		ap_cipher = pBss->WPA.PairCipher;
                                		else
                                        		ap_cipher = Ndis802_11Encryption4Enabled;
                        		}
                        		else if ((ap_auth_mode == Ndis802_11AuthModeWPA2) ||
                                         	(ap_auth_mode == Ndis802_11AuthModeWPA2PSK))
                        		{
                                		if (pBss->WPA2.PairCipherAux == Ndis802_11WEPDisabled)
                                        		ap_cipher = pBss->WPA2.PairCipher;
                                		else
                                        		ap_cipher = Ndis802_11Encryption4Enabled;
                        		}
                		}
                		else if ((pBss->AuthMode == Ndis802_11AuthModeWPAPSK) ||
                                 	(pBss->AuthMode == Ndis802_11AuthModeWPA2PSK))
                		{
                        		if ((pBss->AuthModeAux == Ndis802_11AuthModeWPAPSK) ||
                                	(pBss->AuthModeAux == Ndis802_11AuthModeWPA2PSK))
                                		ap_auth_mode = Ndis802_11AuthModeWPA1PSKWPA2PSK;
                        		else
                               			ap_auth_mode = pBss->AuthMode;

                        		if (pBss->WPA.PairCipher != pBss->WPA2.PairCipher)
                                		ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
 						(pBss->WPA.PairCipherAux != pBss->WPA2.PairCipherAux))
                                			ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
                                         	(pBss->WPA.PairCipherAux == pBss->WPA2.PairCipherAux) &&
                                         	(pBss->WPA.PairCipherAux != Ndis802_11WEPDisabled))
                                			ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
                                         	(pBss->WPA.PairCipherAux == pBss->WPA2.PairCipherAux) &&
                                         	(pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled))
                                			ap_cipher = pBss->WPA.PairCipher;
                		}
                		else if ((pBss->AuthMode == Ndis802_11AuthModeWPA) ||
                                 	(pBss->AuthMode == Ndis802_11AuthModeWPA2))
                		{
                        		if ((pBss->AuthModeAux == Ndis802_11AuthModeWPA) ||
                                	(pBss->AuthMode == Ndis802_11AuthModeWPA2))
                                		ap_auth_mode = Ndis802_11AuthModeWPA1WPA2;
                        		else
                                		ap_auth_mode = pBss->AuthMode;

                        		if (pBss->WPA.PairCipher != pBss->WPA2.PairCipher)
                                		ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
                                        	(pBss->WPA.PairCipherAux != pBss->WPA2.PairCipherAux))
                                			ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
                                         	(pBss->WPA.PairCipherAux == pBss->WPA2.PairCipherAux) &&
                                         	(pBss->WPA.PairCipherAux != Ndis802_11WEPDisabled))
                                			ap_cipher = Ndis802_11Encryption4Enabled;
                        		else if ((pBss->WPA.PairCipher == pBss->WPA2.PairCipher) &&
                                         	(pBss->WPA.PairCipherAux == pBss->WPA2.PairCipherAux) &&
                                         	(pBss->WPA.PairCipherAux == Ndis802_11WEPDisabled))
                                			ap_cipher = pBss->WPA.PairCipher;
                		}

                		sprintf(SecurityStr1, "%s", GetAuthMode((CHAR)ap_auth_mode));             
                		sprintf(SecurityStr2, "%s", GetEncryptType((CHAR)ap_cipher));             
        		}
        		else
        		{
				ap_auth_mode = pBss->AuthMode;
               	 		ap_cipher = pBss->WepStatus;
                		if (ap_cipher == Ndis802_11WEPDisabled)
				{
                        		sprintf(SecurityStr1, "OPEN");
                        		sprintf(SecurityStr2, "NONE");
                		}
				else if (ap_cipher == Ndis802_11WEPEnabled)
                        	{	
					sprintf(SecurityStr1, "OPEN");
					sprintf(SecurityStr2, "WEP");
                		}
				else
				{
                        		sprintf(SecurityStr1, "%s", GetAuthMode((CHAR)ap_auth_mode));     
                        		sprintf(SecurityStr2, "%s", GetEncryptType((CHAR)ap_cipher));     
        			}
			}
			//Authentication Mode
        		len+=sprintf(page+len, "%s\n", SecurityStr1);
			//Encryption Type
        		len+=sprintf(page+len, "%s\n", SecurityStr2);
                	//BSSID
                	len+=sprintf(page+len,"%02x%02x%02x%02x%02x%02x\n",
                        			pBss->Bssid[0],
                        			pBss->Bssid[1],
                        			pBss->Bssid[2],
                        			pBss->Bssid[3],
                        			pBss->Bssid[4],
                        			pBss->Bssid[5]);
			//Channel
                	len+=sprintf(page+len,"%d\n", pBss->Channel);

			//Extension Channel
                        if (pBss->Channel == pBss->CentralChannel)
                       		len+=sprintf(page+len,"%d\n", pBss->Channel);
                       	else if (pBss->Channel > pBss->CentralChannel)
                              	len+=sprintf(page+len,"%d\n", (pBss->Channel-4));
                      	else
                             	len+=sprintf(page+len,"%d\n", (pBss->Channel+4));

                	// Rssi
                	Rssi = (INT)pBss->Rssi;
                	if (Rssi >= -50)
                        	Rssi_Quality = 100;
                	else if (Rssi >= -80)    // between -50 ~ -80dbm
                        	Rssi_Quality = (UINT)(24 + ((Rssi + 80) * 26)/10);
                	else if (Rssi >= -90)   // between -80 ~ -90dbm
                        	Rssi_Quality = (UINT)(((Rssi + 90) * 26)/10);
                	else    // < -84 dbm
                        	Rssi_Quality = 0;
                	len+=sprintf(page+len,"%d\n", Rssi_Quality);
                
			// Wireless Mode
                	wireless_mode = NetworkTypeInUseSanity(pBss);
                	if (wireless_mode == Ndis802_11FH ||
                        	wireless_mode == Ndis802_11DS)
                        	len+=sprintf(page+len,"%d\n", 1);//11b only
               	 	else if (wireless_mode == Ndis802_11OFDM5)
                        	len+=sprintf(page+len,"%d\n", 2);//11a only
                	else if (wireless_mode == Ndis802_11OFDM5_N)
                        	len+=sprintf(page+len,"%d\n", 8);//11a/n mixed
                	else if (wireless_mode == Ndis802_11OFDM24)
                        	len+=sprintf(page+len,"%d\n", 0);//11b/g mixed
                	else if (wireless_mode == Ndis802_11OFDM24_N)
                        	len+=sprintf(page+len,"%d\n", 9);//11b/g/n mixed
                	else
                        	len+=sprintf(page+len,"%d\n", 10);//unknown
                	//Network Type
			if (pBss->BssType == BSS_ADHOC)
                        	len+=sprintf(page+len,"%s\n", "Ad");
                	else
                        	len+=sprintf(page+len,"%s\n", "In");
#ifdef WSC_INCLUDED
        		//WPS
				/*removed by Amit to correspond to the old driver
        		if (pBss->WpsAP & 0x01)
                        	len+=sprintf(page+len,"%s\n", "YES");
                	else
                        	len+=sprintf(page+len,"%s\n", "NO");
				*/
#if 0
                	if (pBss->WscDPIDFromWpsAP == DEV_PASS_ID_PIN)
                        	len+=sprintf(page+len,"%s\n", "PIN");
                	else if (pBss->WscDPIDFromWpsAP == DEV_PASS_ID_PBC)
                        	len+=sprintf(page+len,"%s\n", "PBC");
                	else
                        	len+=sprintf(page+len,"%s\n", " ");
#endif
#endif // WSC_INCLUDED //

#if 0
#ifdef CONFIG_STA_SUPPORT
#ifdef DOT11R_FT_SUPPORT
		if (pBss->bHasMDIE)
		{
			len+=sprintf(page+len," %02x%02x", pBss->FT_MDIE.MdId[0], pBss->FT_MDIE.MdId[1]);
			if (pBss->FT_MDIE.FtCapPlc.field.FtOverDs)
				len+=sprintf(page+len,"%s", " TRUE");
			else
				len+=sprintf(page+len,"%s", " FALSE");
			if (pBss->FT_MDIE.FtCapPlc.field.RsrReqCap)
				len+=sprintf(page+len,"%s\n", " TRUE");
			else
				len+=sprintf(page+len,"%s\n", " FALSE");
		}
#endif // DOT11R_FT_SUPPORT //
#endif // CONFIG_STA_SUPPORT //
#endif
        	}
  	}
        else
       		printk("pAd == NULL\n");

        return len;
}
#endif

int rt2880_module_init(VOID)
{
	struct  net_device		*net_dev;
	ULONG				csr_addr;
	INT					rv;
	PVOID				*handle = NULL;
	RTMP_ADAPTER		*pAd;
	unsigned int			dev_irq;
	RTMP_OS_NETDEV_OP_HOOK	netDevHook;
	

	DBGPRINT(RT_DEBUG_TRACE, ("===> rt2880_probe\n"));	

        int i;
        printk("Length of MAC:%d\n", mac_len);
        printk("<1> mac:");

        mac_len_6 = mac_len;

        for(i=0; i<mac_len; i++){
               printk("%x:", MAC_ADDR[i]);
               mac_addr_6[i] = MAC_ADDR[i];
        }
        printk("\n----\n");

//RtmpRaBusInit============================================
	// map physical address to virtual address for accessing register
	csr_addr = (unsigned long)RTMP_MAC_CSR_ADDR;
	dev_irq = RTMP_MAC_IRQ_NUM;
	

//RtmpDevInit==============================================
	// Allocate RTMP_ADAPTER adapter structure
//	handle = kmalloc(sizeof(struct os_cookie) , GFP_KERNEL);
	os_alloc_mem(NULL, (UCHAR **)&handle, sizeof(struct os_cookie));
	if (!handle)
	{
		DBGPRINT(RT_DEBUG_ERROR, ("Allocate memory for os_cookie failed!\n"));
		goto err_out;
	}
	memset(handle, 0, sizeof(struct os_cookie));

#ifdef OS_ABL_FUNC_SUPPORT
	/* get DRIVER operations */
	RTMP_DRV_OPS_FUNCTION(pRtmpDrvOps, NULL, NULL, NULL);
#endif // OS_ABL_FUNC_SUPPORT //

	rv = RTMPAllocAdapterBlock(handle, &pAd);
	if (rv != NDIS_STATUS_SUCCESS)
	{
		DBGPRINT(RT_DEBUG_ERROR, (" RTMPAllocAdapterBlock !=  NDIS_STATUS_SUCCESS\n"));
//		kfree(handle);
		os_free_mem(NULL, handle);
		
		goto err_out;
	}
	// Here are the RTMP_ADAPTER structure with rbus-bus specific parameters.
	pAd->CSRBaseAddress = (PUCHAR)csr_addr;

	RtmpRaDevCtrlInit(pAd, RTMP_DEV_INF_RBUS);


//NetDevInit==============================================
	net_dev = RtmpPhyNetDevInit(pAd, &netDevHook);
	if (net_dev == NULL)
		goto err_out_free_radev;

	// Here are the net_device structure with pci-bus specific parameters.
	net_dev->irq = dev_irq;			// Interrupt IRQ number
	net_dev->base_addr = csr_addr;		// Save CSR virtual address and irq to device structure
	((POS_COOKIE)handle)->pci_dev = net_dev;

#ifdef CONFIG_STA_SUPPORT
    pAd->StaCfg.OriDevType = net_dev->type;
#endif // CONFIG_STA_SUPPORT //


	
#ifdef RT_CFG80211_SUPPORT
	/*
		In 2.6.32, cfg80211 register must be before register_netdevice();
		We can not put the register in rt28xx_open();
		Or you will suffer NULL pointer in list_add of
		cfg80211_netdev_notifier_call().
	*/
	CFG80211_Register(pAd, pAd->pCfgDev, pNetDev);
#endif // RT_CFG80211_SUPPORT //

//All done, it's time to register the net device to kernel.
	// Register this device
	rv = RtmpOSNetDevAttach(pAd->OpMode, net_dev, &netDevHook);
	if (rv)
	{
		DBGPRINT(RT_DEBUG_ERROR, ("failed to call RtmpOSNetDevAttach(), rv=%d!\n", rv));
		goto err_out_free_netdev;
	}

	// due to we didn't have any hook point when do module remove, we use this static as our hook point.
	rt2880_dev = net_dev;
	
	wl_proc_init();

	DBGPRINT(RT_DEBUG_TRACE, ("%s: at CSR addr 0x%1x, IRQ %d. \n", net_dev->name, (ULONG)csr_addr, net_dev->irq));

	DBGPRINT(RT_DEBUG_TRACE, ("<=== rt2880_probe\n"));
	
	//add by steven for wlan client list
        static struct proc_dir_entry *wlan_dir;
        wlan_dir = proc_mkdir("wlan0", NULL);
        if(wlan_dir == NULL) {
                printk("wlan_dir == NULL\n");
                return -ENOMEM;
        }
        if(create_proc_read_entry("sta_list",0, wlan_dir, sta_list_read, NULL)==NULL) {
                printk("sta_list_read == NULL\n");
                return -ENOMEM;
        }
	//add by steven for scan ap list
        if(create_proc_read_entry("scanap_list",0, wlan_dir, scanap_list_read,(void *)pAd)==NULL) {
        	printk("scanap_list_read == NULL\n");
        	return -ENOMEM;
        }
#if defined(CONFIG_RA_CLASSIFIER)&&(!defined(CONFIG_RA_CLASSIFIER_MODULE)) 	 
    proc_ptr = proc_ralink_wl_video; 	 
    if(ra_classifier_init_func!=NULL) 	 
	    ra_classifier_init_func(); 	 
#endif

	return 0;

err_out_free_netdev:
	RtmpOSNetDevFree(net_dev);

err_out_free_radev:
	/* free RTMP_ADAPTER strcuture and os_cookie*/
	RTMPFreeAdapter(pAd);
		
err_out:
	return -ENODEV;
	
}


VOID rt2880_module_exit(VOID)
{
	struct net_device   *net_dev = rt2880_dev;
	RTMP_ADAPTER *pAd;


	if (net_dev == NULL)
		return;
	
	//pAd = net_dev->priv;
	GET_PAD_FROM_NET_DEV(pAd, net_dev);

	if (pAd != NULL)
	{
		RtmpPhyNetDevExit(pAd, net_dev);
		RtmpRaDevCtrlExit(pAd);
	}
	else
	{
		RtmpOSNetDevDetach(net_dev);
	}
	
	// Free the root net_device.
	RtmpOSNetDevFree(net_dev);
	
#if defined(CONFIG_RA_CLASSIFIER)&&(!defined(CONFIG_RA_CLASSIFIER_MODULE)) 	 
    proc_ptr = proc_ralink_wl_video; 	 
    if(ra_classifier_release_func!=NULL) 	 
	    ra_classifier_release_func(); 	 
#endif

	wl_proc_exit();
}

