/****************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ****************************************************************************

    Module Name:
	led.c
 
    Abstract:
 
    Revision History:
    Who          When          What
    ---------    ----------    ----------------------------------------------
 */

 
#if defined(WLAN_LED)

#ifdef LINUX
#include <linux/config.h>
#include <linux/version.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/timer.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#endif // LINUX //

#include "rt_config.h"
#include "led.h"

//================ AMIT Modify START ================ 2011/7/12 W 10:22:24
#ifdef CONFIG_RT2860V2_AP_LED_WLAN_MAC
//================ AMIT Modify END ================ 2011/7/12 W 10:22:24

#define GetBitX(x, y)			(	((x) & (1 << (y)))>>y		)
#define GetBit(x, y)			(	((x) & (1 << (y)))		)
#define GetBitX(x, y)			(	((x) & (1 << (y)))>>y		)
#define SetBit(x, y)			(	(x) = (x) | (1 << (y))	)
#define ClearBit(x, y)			{	(x) &= (~(1 << (y)));	}
#define DSetBit(x, y)			(	(x) = (1 << (y))		)
#define MakeWord(HI, LO)		(	((WORD)(LO)) | (((WORD)(HI))<<8) )	// Note! LO must be read first
#define HiByte(W)				(	(BYTE)(((WORD)W) >> 8)	)
#define LoByte(W)				(	(BYTE)(W)				)
#define FireInterruptToHost()	{	IntToHost = 0xff;		}

#define LED_CHECK_INTERVAL 	50 /* 50ms */

RALINK_TIMER_STRUCT LedCheckTimer;

unsigned char LinkStatus;
unsigned char GPIOPolarity;
unsigned char SignalStrength;
unsigned char LedBlinkTimer = 0xff;
unsigned long BlinkFor8sTimer;

ULED_PARAMETER LedParameter;
LED_OPERATION_MODE CurrentLedCfg;
BYTE CheckTimerEbl=0;

// Produce CurrentLedCfg and CurrentLedPolarity from LedCfgAct/LedCfgAG/LedPolarity and LinkStatus
// CurrentLedCfg format:
//  [7:4] LED ACT configuration
// 	  0x00: Solid off when Tx
//    0x01: Solid on when Tx
//    0x10: Blink when transmitting data and management packet
//    0x11: Blink when transmitting data, management packet and beacon
//    01xx: Slow blink when no traffic
//  [3:2] LED A configuration
//  [1:0] LED G configuration
//    00: Off		01: On		10: Slow blink		11: Fast blink
// AbstractMacLedCfg format:
//  [5:4] ACT configuration
//  [3:2] LED A configuration
//  [1:0] LED G configuration
//    00: Off		01: On		10: Slow blink		11: Fast blink
// CurrentLedPolarity format:
//  [3] LED ACT polarity inversion when link to A
//  [2] LED ACT polarity
//  [1] LED A
//  [0] LED G
//
//						H2MMailbox
//	SetLinkStatusEntry()	<------------- Driver
//		|
//		V
//	SetLinkStatus()
//		|
//		+--->	CurrentLedPolarity, CurrentLedCfg are generated
//		
//	LedCtrlMainEntry()	<----------------- Driven by 50ms/500ms tick when LedMode is not 0
//		|
//		V
//	LedCtrlMain()
//		|
//		V
//	ChgMacLedCfg()	(The default LED control module)
//		^
//		|----	AbstractMacLedCfg is generated here. MAC LED state is changed in ChgMacLedCfg()
//		

//================ AMIT Modify START ================ 2011/7/12 W 10:22:24
#define LED_CHECK_INTERVAL_WPS 	50

RALINK_TIMER_STRUCT LedCheckTimer;
RALINK_TIMER_STRUCT LedCheckTimer_wps;

unsigned char LinkStatus;
unsigned char GPIOPolarity;
unsigned char SignalStrength;

void SetLinkStatus(IN PRTMP_ADAPTER pAd);

//union uLedParameter LedParameter;

LED_CFG_T LedCfg;
BYTE CheckTimerEbl_wps=0;

enum LED_STATE { SOLID_OFF=0, SOLID_ON, BLINK } led_state ;

//// Entry for Led control.  Triggered by timer per 50ms
//void LedCtrlMain(
//	IN PVOID SystemSpecific1, 
//	IN PVOID FunctionContext, 
//	IN PVOID SystemSpecific2, 
//	IN PVOID SystemSpecific3)
//{
//}

void StopLed(IN PRTMP_ADAPTER pAd)
{
	// disable WPS LED flash
	if(CheckTimerEbl_wps == 1)
	{
		BOOLEAN Cancelled;		
		RTMPCancelTimer(&LedCheckTimer_wps, &Cancelled);
		CheckTimerEbl_wps=0;
	}
	
	LedCfg.word = 0x0;
	// LED off
	RTMP_IO_WRITE32(pAd, LED_CFG, LedCfg.word);

}

void StartLed(IN PRTMP_ADAPTER pAd)
{
	SetLinkStatus(pAd);
}


void LedCtrlMain_wps(IN PVOID data)
//void LedCtrlMain_wps()
{
	RALINK_TIMER_STRUCT *tmp = (RALINK_TIMER_STRUCT *) data;
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *) tmp->cookie;
	
	if (led_state != SOLID_OFF)
	{
		LedCfg.field.LED_POL = 0;
		LedCfg.field.G_LED_MODE = MAC_LED_OFF;
		led_state = SOLID_OFF;
	} else if (led_state != SOLID_ON)
	{
		LedCfg.field.LED_POL = 0;
		LedCfg.field.G_LED_MODE = MAC_LED_ON;
		led_state = SOLID_ON;
	}	
	RTMP_IO_WRITE32(pAd, LED_CFG, LedCfg.word);
	
	RTMPSetTimer(&LedCheckTimer_wps, LED_CHECK_INTERVAL_WPS);
}

void FlashStartLed(IN PRTMP_ADAPTER pAd)
{
	if(CheckTimerEbl_wps == 0)
	{
		RTMPInitTimer(pAd, &LedCheckTimer_wps, LedCtrlMain_wps, pAd, FALSE);
		RTMPSetTimer(&LedCheckTimer_wps, LED_CHECK_INTERVAL_WPS);
		CheckTimerEbl_wps=1;
		led_state=SOLID_OFF;
	}
}


void FlashStopLed(IN PRTMP_ADAPTER pAd)
{
	BOOLEAN Cancelled;		
	RTMPCancelTimer(&LedCheckTimer_wps, &Cancelled);
	CheckTimerEbl_wps=0;
	SetLinkStatus(pAd);
}
//================ AMIT Modify END ================ 2011/7/12 W 10:22:24

INT Show_LedCfg_Proc(
	IN PRTMP_ADAPTER pAd,
	IN PSTRING arg)
{
	LED_CFG_T macLedCfg;
	RTMP_IO_READ32(pAd, MAC_LED_CFG, &macLedCfg.word);

	printk("LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkA=%d\n", LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkA);
	printk("LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkA=%d\n", LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkA);
	printk("LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkG=%d\n", LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkG);
	printk("LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkG=%d\n", LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkG);
	printk("LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkDown=%d\n", LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkDown);
	printk("LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkDown=%d\n", LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkDown);
	printk("LedParameter.LedAgCfg.field.LedAMode_RadioOff=%d\n", LedParameter.LedAgCfg.field.LedAMode_RadioOff);
	printk("LedParameter.LedAgCfg.field.LedGMode_RadioOff=%d\n", LedParameter.LedAgCfg.field.LedGMode_RadioOff);


	printk("LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkA=%d\n", LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkA);
	printk("LedParameter.LedActCfg.field.LedActMode_RadioOnLinkA=%d\n", LedParameter.LedActCfg.field.LedActMode_RadioOnLinkA);
	printk("LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkG=%d\n", LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkG);
	printk("LedParameter.LedActCfg.field.LedActMode_RadioOnLinkG=%d\n", LedParameter.LedActCfg.field.LedActMode_RadioOnLinkG);
	printk("LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkDown=%d\n", LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkDown);
	printk("LedParameter.LedActCfg.field.LedActMode_RadioOnLinkDown=%d\n", LedParameter.LedActCfg.field.LedActMode_RadioOnLinkDown);
	printk("LedParameter.LedActCfg.field.LedActModeNoTx_RadioOff=%d\n", LedParameter.LedActCfg.field.LedActModeNoTx_RadioOff);
	printk("LedParameter.LedActCfg.field.LedActMode_RadioOff=%d\n", LedParameter.LedActCfg.field.LedActMode_RadioOff);


	printk("LED_CFG = %x\n\n", macLedCfg.word);
	printk("LED_ON_TIME = %d\n", macLedCfg.field.LED_ON_TIME);
	printk("LED_OFF_TIME = %d\n", macLedCfg.field.LED_OFF_TIME);
	printk("SLOW_BLK_TIME = %d\n", macLedCfg.field.SLOW_BLK_TIME);
	printk("R_LED_MODE (A) = %d\n", macLedCfg.field.R_LED_MODE);
	printk("G_LED_MODE (ACT) = %d\n", macLedCfg.field.G_LED_MODE);
	printk("Y_LED_MODE (A) = %d\n", macLedCfg.field.Y_LED_MODE);
	printk("LED_POL = %d\n", macLedCfg.field.LED_POL);

	return TRUE;
}

INT Set_LedCfg_Proc(
	IN PRTMP_ADAPTER pAd,
	IN PSTRING arg)
{
	INT loop;
	PCHAR thisChar;
	long polarity=0;
	long ledOnTime=0;
	long ledOffTime=0;
	long slowBlkTime=0;
	
	loop = 0;

	while ((thisChar = strsep((char **)&arg, "-")) != NULL)
	{
		switch(loop)
		{
			case 0:
				polarity = simple_strtol(thisChar, 0, 10);
				break;

			case 1:
				ledOnTime = simple_strtol(thisChar, 0, 10);
				break;

			case 2:
				ledOffTime = simple_strtol(thisChar, 0, 10);
				break;

			case 3:
				slowBlkTime = simple_strtol(thisChar, 0, 10);
				break;

			default:
				break;
		}
		loop ++;
	}

	SetLedCfg(pAd, (INT)polarity, (INT)ledOnTime, (INT)ledOffTime, (INT)slowBlkTime);

	return TRUE;
}

INT Set_LedCheck_Proc(
	IN PRTMP_ADAPTER pAd,
	IN PSTRING arg)
{
	INT loop;
	PCHAR thisChar;
	long ledSel=0;
	long ledMode=0;

	loop = 0;
	while ((thisChar = strsep((char **)&arg, "-")) != NULL)
	{
		switch(loop)
		{
			case 0:
				ledSel = simple_strtol(thisChar, 0, 10);
				break;

			case 1:
				ledMode = simple_strtol(thisChar, 0, 10);
				break;

			default:
				break;
		}
		loop ++;
	}

	SetLedMode(pAd, (INT)ledSel, (INT)ledMode);

	return TRUE;
}

VOID SetLedCfg(
	IN PRTMP_ADAPTER pAd,
	IN INT ledPolarity,
	IN INT ledOnTime,
	IN INT ledOffTime,
	IN INT slowBlkTime)
{
	LED_CFG_T macLedCfg;
	RTMP_IO_READ32(pAd, MAC_LED_CFG, &macLedCfg.word);

	macLedCfg.field.LED_POL = ledPolarity;
	macLedCfg.field.LED_ON_TIME = ledOnTime;
	macLedCfg.field.LED_OFF_TIME = ledOffTime;
	macLedCfg.field.SLOW_BLK_TIME = slowBlkTime;

	RTMP_IO_WRITE32(pAd, MAC_LED_CFG, macLedCfg.word);

	return;
}

VOID SetLedMode(
	IN PRTMP_ADAPTER pAd,
	IN INT LedSel,
	IN INT LedMode)
{
	LED_CFG_T macLedCfg;
	RTMP_IO_READ32(pAd, MAC_LED_CFG, &macLedCfg.word);

	switch(LedSel)
	{
		case LED_G: /* LED G. */
			macLedCfg.field.Y_LED_MODE = LedMode;
			break;

		case LED_A: /* LED A. */
			macLedCfg.field.G_LED_MODE = LedMode;
			break;

		case LED_ACT: /* LED ACT. */
			macLedCfg.field.R_LED_MODE = LedMode;
			break;

		default:
			break;
	}

	RTMP_IO_WRITE32(pAd, MAC_LED_CFG, macLedCfg.word);

	return;
}

// Called when host sets LED mode.
// Called in interrupt level
void SetLinkStatus(IN PRTMP_ADAPTER pAd)
{
	BlinkFor8sTimer = 0;
	switch(LinkStatus)
	{
		case 0x00:		// Radio off
			CurrentLedCfg.field.LedGMode = LedParameter.LedAgCfg.field.LedGMode_RadioOff;
			CurrentLedCfg.field.LedAMode = LedParameter.LedAgCfg.field.LedAMode_RadioOff;
			CurrentLedCfg.field.LedActMode = LedParameter.LedActCfg.field.LedActMode_RadioOff;
			CurrentLedCfg.field.LedActModeNoTx = LedParameter.LedActCfg.field.LedActModeNoTx_RadioOff;
			CurrentLedCfg.field.LedGPolarity = LedParameter.LedPolarityCfg.field.LedGPolarity_RadioOff;
			CurrentLedCfg.field.LedAPolarity = LedParameter.LedPolarityCfg.field.LedAPolarity_RadioOff;
			CurrentLedCfg.field.LedActPolarity = LedParameter.LedPolarityCfg.field.LedActPolarity_RadioOff;
			break;

		case 0x20:		// Radio on but not link up
			CurrentLedCfg.field.LedGMode = LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkDown;
			CurrentLedCfg.field.LedAMode = LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkDown;
			CurrentLedCfg.field.LedActMode = LedParameter.LedActCfg.field.LedActMode_RadioOnLinkDown;
			CurrentLedCfg.field.LedActModeNoTx = LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkDown;
			CurrentLedCfg.field.LedGPolarity = LedParameter.LedPolarityCfg.field.LedGPolarity_RadioOnLinkDown;
			CurrentLedCfg.field.LedAPolarity = LedParameter.LedPolarityCfg.field.LedAPolarity_RadioOnLinkDown;
			CurrentLedCfg.field.LedActPolarity = LedParameter.LedPolarityCfg.field.LedActPolarity_RadioOnLinkDown;
  			break;

		case 0x60:		// Radio on and link to G
			CurrentLedCfg.field.LedGMode = LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkG;
			CurrentLedCfg.field.LedAMode = LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkG;
			CurrentLedCfg.field.LedActMode = LedParameter.LedActCfg.field.LedActMode_RadioOnLinkG;
			CurrentLedCfg.field.LedActModeNoTx = LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkG;
			CurrentLedCfg.field.LedGPolarity = LedParameter.LedPolarityCfg.field.LedGPolarity_RadioOnLinkG;
			CurrentLedCfg.field.LedAPolarity = LedParameter.LedPolarityCfg.field.LedAPolarity_RadioOnLinkG;
			CurrentLedCfg.field.LedActPolarity = LedParameter.LedPolarityCfg.field.LedActPolarity_RadioOnLinkG;
  			break;

		case 0xa0:		// Radio on and link to A
			CurrentLedCfg.field.LedGMode = LedParameter.LedAgCfg.field.LedGMode_RadioOnLinkA;
			CurrentLedCfg.field.LedAMode = LedParameter.LedAgCfg.field.LedAMode_RadioOnLinkA;
			CurrentLedCfg.field.LedActMode = LedParameter.LedActCfg.field.LedActMode_RadioOnLinkA;
			CurrentLedCfg.field.LedActModeNoTx = LedParameter.LedActCfg.field.LedActModeNoTx_RadioOnLinkA;
			CurrentLedCfg.field.LedGPolarity = LedParameter.LedPolarityCfg.field.LedGPolarity_RadioOnLinkA;
			CurrentLedCfg.field.LedAPolarity = LedParameter.LedPolarityCfg.field.LedAPolarity_RadioOnLinkA;
			CurrentLedCfg.field.LedActPolarity = LedParameter.LedPolarityCfg.field.LedActPolarity_RadioOnLinkA;
  			break;

		case 0x10:		// WPS
			if(LedParameter.LedMode == 0x04)
			{
				CurrentLedCfg.field.LedActPolarity = 0;
				CurrentLedCfg.field.LedActMode = 1;	// Force ACT to solid on/off
				CurrentLedCfg.field.LedActMode = 0;	// Force ACT to solid on/off
			}
			if(LedParameter.LedMode == 0x05)
			{
				CurrentLedCfg.field.LedActPolarity = 1;
				CurrentLedCfg.field.LedActMode = 1;	// Force ACT to solid on/off
				CurrentLedCfg.field.LedActMode = 0;	// Force ACT to solid on/off
			}
			break;

		case 0x08:
			if (LedParameter.LedMode == 2)
				BlinkFor8sTimer = (8000 / LED_CHECK_INTERVAL);
			break;
	}

	if(CheckTimerEbl==0)
	{
		memset(&LedCheckTimer, 0, sizeof(RALINK_TIMER_STRUCT));
		RTMPInitTimer(pAd, &LedCheckTimer, GET_TIMER_FUNCTION(LedCtrlMain), pAd, TRUE);
		RTMPSetTimer(&LedCheckTimer, LED_CHECK_INTERVAL);

		CheckTimerEbl=1;
	}
}


void SetLinkStatusEntry(IN PRTMP_ADAPTER pAd)
{	
	SetLinkStatus(pAd);	
}	// @ 0x1025


// Entry for Led control.  Triggered by timer per 50ms
void LedCtrlMain(
	IN PVOID SystemSpecific1, 
	IN PVOID FunctionContext, 
	IN PVOID SystemSpecific2, 
	IN PVOID SystemSpecific3)
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)FunctionContext;

	switch(LedParameter.LedMode)
	{
		case 0:		// Hardware controlled mode. Just ignore it.
			return;
		case 0x40:	// In addition to mode 0, set signal strength LED
			ChgSignalStrengthLed(pAd);
		default:
			ChgMacLedCfg(pAd);
			break;
	}

	if(LedBlinkTimer!=0)
		LedBlinkTimer--;
	else
		LedBlinkTimer = 0xff;
}


static inline int TX_TRAFFIC_EXIST(
	IN PRTMP_ADAPTER pAd)
{
	UINT RegValue;

	RTMP_IO_READ32(pAd, MCU_INT_STATUS, &RegValue);
	return (RegValue & 0x0e);
}

static inline int BEN_TC_ACT(
	IN PRTMP_ADAPTER pAd)
{
	UINT RegValue;

	RTMP_IO_READ32(pAd, MCU_INT_STATUS, &RegValue);
	return (RegValue & 0x10);
}

// Change LED State according to CurrentLedPolarity, CurrentLedCfg, and Tx activity
// The result is stored in AbstractMacLedCfg (Abstract MacLedCfg).
// AbstractMacLedCfg is an abstract layer. Since MAC's LED_CFG doesn't match firmware requirement totally,
// this abstract layer is to hide these difference.  
void ChgMacLedCfg(
	IN PRTMP_ADAPTER pAd)
{
	LED_CFG_T LedCfgBuf;
	BYTE DataTxActivity, BeaconTxActivity;
	extern ULONG WlanLed;


	/* 
	** MCU_INT_STA (offset: 0x0414)
	** bit 1: MTX2_INT, TX2Q to MAC frame transfer complete interrupt.
	** bit 2: MTX1_INT, TX1Q to MAC frame transfer complete interrupt.
	** bit 3: MTX0_INT, TX0Q to MAC frame transfer complete interrupt.
	*/

	if (TX_TRAFFIC_EXIST(pAd)) // Check if there is Tx Traffic
		DataTxActivity = 1;
	else
		DataTxActivity = 0;

	// Check if there are beacon
	BeaconTxActivity = BEN_TC_ACT(pAd);

	// Clear Tx and beacon Tx complete interrupt
	RTMP_IO_WRITE32(pAd, MCU_INT_STATUS, 0x1e);

	RTMP_IO_READ32(pAd, MAC_LED_CFG, &LedCfgBuf.word);

	/* For backward compatible issue,
         * LedActMode: 0: None, 1: Solid ON, 2: Blink (data/mgr), 3: Blink (data,mgr,beacon)
	 * =>Solid off = solid on + high polarity
         */
	LedCfgBuf.field.LED_POL = CurrentLedCfg.field.LedActPolarity;

	/* LED Act. connect to G_LED. */
	if (LedParameter.LedMode == 2 && BlinkFor8sTimer)
	{
		UINT8 LedPolarity = CurrentLedCfg.field.LedActPolarity ? 0 : 3;
		LedCfgBuf.field.G_LED_MODE = GetBitX(LedBlinkTimer, 0) ? LedPolarity : ~LedPolarity;
		BlinkFor8sTimer--;
	}
	else if (CurrentLedCfg.field.LedActMode == 0) /* dark. */
	{
		LedCfgBuf.field.G_LED_MODE =
				CurrentLedCfg.field.LedActPolarity ? 3 : 0;	/* dark mode. */
	}
	else if (CurrentLedCfg.field.LedActMode == 1) /* solid on. */
	{
		LedCfgBuf.field.G_LED_MODE =
				CurrentLedCfg.field.LedActPolarity ? 0 : 3;	/* solid on mode. */
	}
	else if ((DataTxActivity && CurrentLedCfg.field.LedActMode > 1) /* Data packet transmited. */
		|| (BeaconTxActivity && CurrentLedCfg.field.LedActMode == 3)) /* Beacon frame transmited. */
	{
		LedCfgBuf.field.G_LED_MODE = GetBitX(LedBlinkTimer, 0) ? 3 : 0;
	}
	else if (!DataTxActivity && !BeaconTxActivity)
	{
		if (CurrentLedCfg.field.LedActModeNoTx == 0) /* solid on when no tx. */
			LedCfgBuf.field.G_LED_MODE =
				CurrentLedCfg.field.LedActPolarity ? 0 : 3;	/* solid on mode. */
		else /* slow blink. */
			LedCfgBuf.field.G_LED_MODE = GetBitX(LedBlinkTimer, 4) ? 3 : 0;
	}


	/* LED G. connect to Y_LED. */
	if (CurrentLedCfg.field.LedGMode == 3)	/* fast blinking. */
		LedCfgBuf.field.Y_LED_MODE = GetBitX(LedBlinkTimer, 0) ? 3 : 0;
	else if (CurrentLedCfg.field.LedGMode == 2) /* slow blinkg. */
		LedCfgBuf.field.Y_LED_MODE = GetBitX(LedBlinkTimer, 4) ? 3 : 0;
	else if (CurrentLedCfg.field.LedGMode == 1)	/* solid on. */
		LedCfgBuf.field.Y_LED_MODE =
			CurrentLedCfg.field.LedGPolarity ? 0 : 3;	/* solid on mode. */
	else /* dark */
		LedCfgBuf.field.Y_LED_MODE =
			CurrentLedCfg.field.LedGPolarity ? 3 : 0;	/* dark mode. */

	/* LED A. connect to R_LED. */
	if (CurrentLedCfg.field.LedAMode == 3)	/* fast blinking. */
		LedCfgBuf.field.R_LED_MODE = GetBitX(LedBlinkTimer, 0) ? 3 : 0;
	else if (CurrentLedCfg.field.LedAMode ==  2) /* slow blinkg. */
		LedCfgBuf.field.R_LED_MODE = GetBitX(LedBlinkTimer, 4) ? 3 : 0;
	else if (CurrentLedCfg.field.LedAMode == 1)	/* solid on. */
		LedCfgBuf.field.R_LED_MODE =
			CurrentLedCfg.field.LedAPolarity ? 0 : 3;	/* solid on mode. */
	else /* dark */
		LedCfgBuf.field.R_LED_MODE =
			CurrentLedCfg.field.LedAPolarity ? 3 : 0;	/* dark mode. */

	if ( (WlanLed == 0) ||
		RTMP_TEST_FLAG(pAd, fRTMP_ADAPTER_RADIO_OFF)) {
	    RTMP_IO_WRITE32(pAd, MAC_LED_CFG, 0);
	} else {
	RTMP_IO_WRITE32(pAd, MAC_LED_CFG, LedCfgBuf.word);
	}

	return;
}


void ChgSignalStrengthLed(
		IN PRTMP_ADAPTER pAd)
{
	RTMP_IO_WRITE32(pAd, GPIO_DIR, 0x00); /* set GPIO to output. */
	RTMP_IO_WRITE32(pAd, GPIO_DAT, (GPIOPolarity ? SignalStrength : ~SignalStrength));
}

#ifdef OS_ABL_SUPPORT
EXPORT_SYMBOL(LedCheckTimer);
EXPORT_SYMBOL(CheckTimerEbl);
#endif // OS_ABL_SUPPORT //

//================ AMIT Modify START ================ 2011/7/12 W 10:22:24
#else

#define LED_GPIO CONFIG_RT2860V2_LED_GPIO

#define LED_CHECK_INTERVAL 		500 /* 50ms */
#define LED_CHECK_INTERVAL_WPS 	50 /* 1ms */


#define RALINK_PIO_BASE                 0xB0000600
#define RALINK_PRGIO_ADDR		RALINK_PIO_BASE // Programmable I/O
#define RALINK_REG_PIODATA							(RALINK_PRGIO_ADDR + 0x20)
#define RALINK_REG_PIO3924DATA          (RALINK_PRGIO_ADDR + 0x48)
#define RALINK_REG_PIO5140DATA          (RALINK_PRGIO_ADDR + 0x70)
#define RALINK_REG_PIO7140DATA          (RALINK_PRGIO_ADDR + 0x70)
#define RALINK_REG_PIO9572DATA          (RALINK_PRGIO_ADDR + 0x98)

#define RALINK_GPIO_0			0x00000001
#define RALINK_GPIO_1			0x00000002
#define RALINK_GPIO_2			0x00000004
#define RALINK_GPIO_3			0x00000008
#define RALINK_GPIO_4			0x00000010
#define RALINK_GPIO_5			0x00000020
#define RALINK_GPIO_6			0x00000040
#define RALINK_GPIO_7			0x00000080
#define RALINK_GPIO_8			0x00000100
#define RALINK_GPIO_9			0x00000200
#define RALINK_GPIO_10			0x00000400
#define RALINK_GPIO_11			0x00000800
#define RALINK_GPIO_12			0x00001000
#define RALINK_GPIO_13			0x00002000
#define RALINK_GPIO_14			0x00004000
#define RALINK_GPIO_15			0x00008000
#define RALINK_GPIO_16			0x00010000
#define RALINK_GPIO_17			0x00020000
#define RALINK_GPIO_18			0x00040000
#define RALINK_GPIO_19			0x00080000
#define RALINK_GPIO_20			0x00100000
#define RALINK_GPIO_21			0x00200000
#define RALINK_GPIO_22			0x00400000
#define RALINK_GPIO_23			0x00800000
#define RALINK_GPIO(x)			(1 << x)


#define __LED_ON(gpio) ralink_gpio_led_value |= RALINK_GPIO(gpio);
#define __LED_OFF(gpio) ralink_gpio_led_value &= ~RALINK_GPIO(gpio);

u32 ralink_gpio_led_value = 0;


RALINK_TIMER_STRUCT LedCheckTimer;
RALINK_TIMER_STRUCT LedCheckTimer_wps;
typedef struct {
        int gpio;                       //gpio number (0 ~ 23)
        unsigned int on;                //interval of led on
        unsigned int off;               //interval of led off
        unsigned int blinks;            //number of blinking cycles
        unsigned int rests;             //number of break cycles
        unsigned int times;             //blinking times
} ralink_gpio_led_info;

void SetLinkStatus(IN PRTMP_ADAPTER pAd);


unsigned char LinkStatus;
unsigned char SignalStrength;
unsigned char GPIOPolarity;
ULED_PARAMETER LedParameter;
int ralink_gpio_led_set(ralink_gpio_led_info led);

BYTE CheckTimerEbl=0;
BYTE CheckTimerEbl_wps=0;

enum LED_STATE { SOLID_OFF=0, SOLID_ON, BLINK } led_state ;

// Called when host sets LED mode.
// Called in interrupt level
void SetLinkStatus(IN PRTMP_ADAPTER pAd)
{	
	if(CheckTimerEbl==0){
		memset(&LedCheckTimer, 0, sizeof(RALINK_TIMER_STRUCT));
                RTMPInitTimer(pAd, &LedCheckTimer,GET_TIMER_FUNCTION(LedCtrlMain), pAd, TRUE);
                RTMPSetTimer(&LedCheckTimer, LED_CHECK_INTERVAL);
                CheckTimerEbl=1;
		led_state=SOLID_OFF ;
	}	
	//printk(KERN_INFO "%s : LinkStatus=%02x \n", __FUNCTION__, LinkStatus);			
}

static inline int TX_TRAFFIC_EXIST(
        IN PRTMP_ADAPTER pAd)
{
        UINT RegValue;

        RTMP_IO_READ32(pAd, MCU_INT_STATUS, &RegValue);
        return (RegValue & 0x0e);
}

// Entry for Led control.  Triggered by timer per 50ms
void LedCtrlMain(
	IN PVOID SystemSpecific1,
        IN PVOID FunctionContext,
        IN PVOID SystemSpecific2,
        IN PVOID SystemSpecific3)
{
	RTMP_ADAPTER *pAd = (RTMP_ADAPTER *)FunctionContext;
	ralink_gpio_led_info led;	
	if (TX_TRAFFIC_EXIST(pAd)) // Check if there is Tx Traffic
	{
		if( led_state != BLINK ){
			led_state = BLINK;
			led.gpio=LED_GPIO;
                	led.on=1;
                	led.off=1;
                	led.blinks=4000;
                	led.rests=0;
                	led.times=4000;
                	ralink_gpio_led_set(led);	
		}	
	}else{
		
		if( led_state != SOLID_ON){
			led_state = SOLID_ON;
			led.gpio=LED_GPIO;
                        led.on=4000;
                        led.off=0;
                        led.blinks=1;
                        led.rests=0;
                        led.times=4000;
                        ralink_gpio_led_set(led);
		}
	}
	// Clear Tx and beacon Tx complete interrupt
        RTMP_IO_WRITE32(pAd, MCU_INT_STATUS, 0x1e);	
	RTMPSetTimer(&LedCheckTimer, LED_CHECK_INTERVAL);
}

void StopLed(IN PRTMP_ADAPTER pAd)
{
	BOOLEAN Cancelled;	
	ralink_gpio_led_info led;	
	RTMPCancelTimer(&LedCheckTimer, &Cancelled);	
	//Led Off
	led.gpio=LED_GPIO;
        led.on=0;
       	led.off=4000;
       	led.blinks=0;
      	led.rests=1;
      	led.times=4000;
    	ralink_gpio_led_set(led);
	CheckTimerEbl=0;
}

void StartLed(IN PRTMP_ADAPTER pAd)
{
	SetLinkStatus(pAd);
}



void FlashStartLed(IN PRTMP_ADAPTER pAd)
{
	//printk(KERN_INFO "%s : LinkStatus=wuming \n", __FUNCTION__);
		
	if(CheckTimerEbl_wps==0){
		memset(&LedCheckTimer_wps, 0, sizeof(RALINK_TIMER_STRUCT));
    RTMPInitTimer(pAd, &LedCheckTimer_wps, GET_TIMER_FUNCTION(LedCtrlMain_wps), pAd, TRUE);
    RTMPSetTimer(&LedCheckTimer_wps, LED_CHECK_INTERVAL);
    CheckTimerEbl_wps=1;
		led_state=SOLID_OFF ;
	}
}


void FlashStopLed(IN PRTMP_ADAPTER pAd)
{
	BOOLEAN Cancelled;
	ralink_gpio_led_info led;		
	RTMPCancelTimer(&LedCheckTimer_wps, &Cancelled);
	//Led Off
	led.gpio=LED_GPIO;
        led.on=0;
        led.off=4000;
        led.blinks=0;
        led.rests=1;
        led.times=4000;
        ralink_gpio_led_set(led);
	CheckTimerEbl_wps=0;
}		

void LedCtrlMain_wps(
	IN PVOID SystemSpecific1,
        IN PVOID FunctionContext,
        IN PVOID SystemSpecific2,
        IN PVOID SystemSpecific3)
{
	if( led_state != SOLID_OFF )
	{
		
		if(LED_GPIO<=23)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIODATA);
			__LED_OFF(LED_GPIO);
			*(volatile u32 *)(RALINK_REG_PIODATA) = ralink_gpio_led_value;
		}
		else if(LED_GPIO<=39)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO3924DATA);
			__LED_OFF(LED_GPIO-24);			
			*(volatile u32 *)(RALINK_REG_PIO3924DATA) = ralink_gpio_led_value;
		}
		else if(LED_GPIO<=39)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO3924DATA);
			__LED_OFF(LED_GPIO-24);			
			*(volatile u32 *)(RALINK_REG_PIO3924DATA) = ralink_gpio_led_value;
		}
#ifdef CONFIG_RALINK_RT3883
		else if(LED_GPIO<=71)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO7140DATA);
			__LED_OFF(LED_GPIO-40);			
			*(volatile u32 *)(RALINK_REG_PIO7140DATA) = ralink_gpio_led_value;
		}
		else
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO9572DATA);
			__LED_OFF(LED_GPIO-72);			
			*(volatile u32 *)(RALINK_REG_PIO9572DATA) = ralink_gpio_led_value;			
		}
#else
		else
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO5140DATA);
			__LED_OFF(LED_GPIO-40);			
			*(volatile u32 *)(RALINK_REG_PIO5140DATA) = ralink_gpio_led_value;			
		}
#endif			
		
 		//printk(KERN_INFO "%s :SOLID_OFF ralink_gpio_led_value = 0x%x  \n", __FUNCTION__, ralink_gpio_led_value);
		led_state = SOLID_OFF;
	}	
	else if( led_state != SOLID_ON)
	{		
		if(LED_GPIO<=23)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIODATA);
			__LED_ON(LED_GPIO);
			*(volatile u32 *)(RALINK_REG_PIODATA) = ralink_gpio_led_value;			
		}
		else if(LED_GPIO<=39)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO3924DATA);
			__LED_ON(LED_GPIO-24);			
			*(volatile u32 *)(RALINK_REG_PIO3924DATA) = ralink_gpio_led_value;
		}
		else if(LED_GPIO<=39)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO3924DATA);
			__LED_ON(LED_GPIO-24);			
			*(volatile u32 *)(RALINK_REG_PIO3924DATA) = ralink_gpio_led_value;
		}
#ifdef CONFIG_RALINK_RT3883
		else if(LED_GPIO<=71)
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO7140DATA);
			__LED_ON(LED_GPIO-40);			
			*(volatile u32 *)(RALINK_REG_PIO7140DATA) = ralink_gpio_led_value;
		}
		else
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO9572DATA);
			__LED_ON(LED_GPIO-72);			
			*(volatile u32 *)(RALINK_REG_PIO9572DATA) = ralink_gpio_led_value;			
		}
#else
		else
		{
			ralink_gpio_led_value = *(volatile u32 *)(RALINK_REG_PIO5140DATA);
			__LED_ON(LED_GPIO-40);			
			*(volatile u32 *)(RALINK_REG_PIO5140DATA) = ralink_gpio_led_value;			
		}
#endif
				
		led_state = SOLID_ON;
	}
	RTMPSetTimer(&LedCheckTimer_wps, LED_CHECK_INTERVAL_WPS);
}
#endif
//================ AMIT Modify END ================ 2011/7/12 W 10:22:24

#endif

