#include "dsll2.h"

#define HOST_MSG_ADDR 0x12
#define HOST_MSG_CTRL 0x12


mt_ret send_eoc_frame(mt_uint32 portid, mt_uint8 count, mt_uint8 *pdata)
{
	mt_uint8 cbuf[256+5];
	mt_ret ret;
	//int tmp_hdlc_frame;
	
	dsl_er(check_param(MT_PAR_PORT,0,portid));

	//tmp_hdlc_frame=hdlc_frame;
	//hdlc_frame=1;

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;

	cbuf[3] = 0x05;

	cbuf[4] = count;
	memcpy(cbuf+5, pdata, count);
	ret = send_frame_port(portid, count+5, cbuf);
	PRINTL(DBG_LVL_EOC,"send_eoc_frame return %i\n",ret);

	//hdlc_frame=tmp_hdlc_frame;

	return MT_OK;
}


mt_ret recv_eoc_frame(mt_uint32 portid, mt_uint16 *count, mt_uint8 *pdata)
{
	mt_uint8 cbuf[4];
	mt_ret ret;
	int i;

	dsl_er(check_param(MT_PAR_PORT,0,portid));

	cbuf[0] = HOST_MSG_ADDR;
	cbuf[1] = HOST_MSG_CTRL;

	cbuf[3] = 0x06;
	
	ret = send_frame_port(portid, 4, cbuf);
	PRINTL(DBG_LVL_EOC,"recv_eoc_frame return %i\n",ret);

	if( ret != MT_OK ) return ret;

	get_port_eoc_buffer(portid, count, pdata);
	PRINTD("count=%i\n", *count);
	for(i=0;i<*count;i++)
		PRINTD("%02x ", pdata[i]);
	PRINTD("\n");

	return MT_OK;
}


mt_uint32 ctrl_eoc_frame(mt_uint8* outputbuf, mt_uint8* inputbuf, mt_uint32 inputbuflen)
{
	mt_uint16 fcs = HDLC_FCS_INIT;
	mt_uint32 outputbuflen = 0;
	mt_uint8  txbyte,i;

	outputbuf[outputbuflen++] = HDLC_LIMITER_FLAG;
	outputbuf[outputbuflen++] = EOC_EXT_MSG;
	fcs = fcs_update(EOC_EXT_MSG,fcs);

	i = 0;
	while(inputbuflen--){
		txbyte = inputbuf[i++];
		fcs = fcs_update(txbyte,fcs);
		if ( txbyte == 0x7E)
		{
			outputbuf[outputbuflen++] = 0x7D;
			outputbuf[outputbuflen++] = 0x5E;
			if(outputbuflen>254)
			{
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
		else
		if ( txbyte == 0x7D)
		{
			outputbuf[outputbuflen++] = 0x7D;
			outputbuf[outputbuflen++] = 0x5D;
			if(outputbuflen>254)
			{
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
		else 
		{
			outputbuf[outputbuflen++] = txbyte;
			if(outputbuflen>254)
			{
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
	}
	fcs = ~fcs;
	for(i = 0; i < 2; i ++){ // octet transparency to be applied to the calculated fcs too. 
		txbyte = fcs & 0x00FF;
		if(txbyte == 0x7E){
			outputbuf[outputbuflen++] = 0x7D;
			outputbuf[outputbuflen++] = 0x5E;
			if(outputbuflen>254){
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
		else if ( txbyte == 0x7D){
			outputbuf[outputbuflen++] = 0x7D;
			outputbuf[outputbuflen++] = 0x5D;
			if(outputbuflen>254){
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
		else 
		{
			outputbuf[outputbuflen++] = txbyte;
			if(outputbuflen>254)
			{
				PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);
				return 0;
			}
		}
		fcs = fcs >> 8;
	}
	outputbuf[outputbuflen++] = HDLC_LIMITER_FLAG;
	if(outputbuflen>256)
		PRINTL(DBG_LVL_EOC,"EOC data frame: inputbuflen %i is too big\n", inputbuflen);

	return outputbuflen;
}
