/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.5 $
* Date:         $Date: 2009-06-18 05:32:47 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#define VDSL_MAJOR 109

#define VDSL_DOWNLOAD_FIRMWARE	0x7600	//mt_ret download_firmware(mt_uint8 chipid, mt_uint8 cmdID, mt_uint16 bufsize, mt_uint8* buffer);
//Init Function
//#define VDSL_INIT_SYSTEM	0x7601	//mt_uint32 init_system(void);
#define VDSL_LOAD_FIRMWARE_BINDRV	0x7601	//mt_ret load_firmware_bindrv(mt_uint8 cmdID, mt_uint16 bufsize, mt_uint8* buffer);
#define VDSL_INIT_CHIP	0x7602	//mt_uint32 init_chip(mt_uint32 chipid, mt_uint32 firmwareID);
#define VDSL_INIT_MODEM	0x7603	//mt_ret init_modem(mt_uint32 chipid);
#define VDSL_RESET_MODEM	0x7604	//mt_ret reset_modem(mt_uint32 chipid);
//Port Function
#define VDSL_CONNECT_PORT	0x7605	//mt_ret connect_port(mt_uint32 portid);
#define VDSL_DISCONNECT_PORT	0x7606	//mt_ret disconnect_port(mt_uint32 portid);
#define VDSL_CLEAR_PORT_STATS	0x7607	//mt_ret clear_port_stats(mt_uint32 portid);
//Shutdown Function
#define VDSL_SHUTDOWN_SYSTEM	0x7608	//mt_ret shutdown_system(void);
#define VDSL_SHUTDOWN_CHIP	0x7609	//mt_ret shutdown_chip(mt_uint32 chipid);
//System Function
#define VDSL_GET_SYSTEM_INFO	0x760a	//void get_system_info(sys_info_struct *psi);
#define VDSL_GET_ALARMS	0x760b	//mt_ret get_alarms(AlarmStruct* pAlarm);
#define VDSL_CLEAR_ALARMS	0x760c	//mt_ret clear_alarms(void);
//Diagnostic Funtions
#define VDSL_SYSTEM_RUN_DIAG_TESTS	0x760d	//mt_ret system_run_diag_tests(void);
#define VDSL_CHIP_RUN_DIAG_TESTS	0x760e	//mt_ret chip_run_diag_tests(void);
#define VDSL_PORT_RUN_DIAG_TESTS	0x760f	//mt_ret port_run_diag_tests(void);					  
// Following unction implementation in vdsllib.c
// -------------------------- MIB  -----------------------
#define VDSL_GET_PORT_MIB	0x7610	//mt_ret get_port_mib(mt_uint32 portid, mt_uint8 *loid, mt_uint8 *strvalue);
#define VDSL_SET_PORT_MIB	0x7611	//mt_ret set_port_mib(mt_uint32 portid, mt_uint8 *loid, mt_uint8 *strvalue);
#define VDSL_GET_PORT_MIB_ARRAY	0x7612	//mt_ret get_port_mib_array(mt_uint32 portid,mt_uint8 tableid,mt_uint8 idx, mt_uint8 interval,mt_uint32* value);
#define VDSL_SET_PORT_MIB_ARRAY	0x7613	//mt_ret set_port_mib_array(mt_uint32 portid, mt_uint32 idx, mt_uint32 count_of_array, mib_value_set *mib_array);
#define VDSL_GET_PHY_STATUS	0x7614	//mt_ret get_phy_status(mt_uint32 portid, mt_uint8 *phy_status, mt_uint8 *conn_status);
#define VDSL_GET_OP_STATE	0x7615	//mt_ret get_op_status(mt_uint32 portid, mt_uint8 *state);
// ---------------------------- Conf Profile Management -------------------
#define VDSL_INIT_CONF_PROFILE	0x7616	//mt_ret init_conf_profile(mt_uint32 portid,conf_profile_struct *ps);
#define VDSL_GET_CONF_PROFILE	0x7617	//mt_ret get_conf_profile(mt_uint32 portid,conf_profile_struct *ps);
#define VDSL_SET_CONF_PROFILE	0x7618	//int set_conf_profile(mt_uint32 portid, conf_profile_struct *ps);
// ---------------------------- Alarm Profile Management -------------------
#define VDSL_INIT_ALARM_CONF_PROFILE	0x7619	//mt_ret init_alarm_conf_profile(mt_uint32 portid,alarm_profile_struct *ps);
#define VDSL_SET_ALARM_PROFILE	0x761a	//mt_ret set_alarm_profile(mt_uint32 portid,alarm_profile_struct *ps);
#define VDSL_GET_ALARM_PROFILE	0x761b	//mt_ret get_alarm_profile(mt_uint32 portid,alarm_profile_struct *ps);
// -------------------------- Statistic Routine -----------------------
#define VDSL_MT_PERF_15_MIN	0x761c	//mt_ret mt_perf_15min(void);
#define VDSL_MT_PERF_24_HOUR	0x761d	//mt_ret mt_perf_24hour(void);
#define VDSL_STATISTIC_TRIGGER	0x761e	//mt_ret statistic_trigger(void);
// -------------------------- Notification -----------------------
#define VDSL_SETUP_NOTIFICATION	0x761f	//mt_ret setup_notification(notification_param nparam);
#define VDSL_REMOVE_NOTIFICATION	0x7620	//mt_ret remove_notification(notification_param nparam);
#define VDSL_MASK_NOTIFICATION	0x7621	//mt_ret mask_notification(mt_uint32 nId);
#define VDSL_PROCESS_NOTIFICATION	0x7622	//mt_ret process_notification(void);
// -------------------------- Memory  -----------------------
#define VDSL_GET_PORT_MEM	0x7623	//mt_ret get_port_mem(mt_uint32 portid, mt_uint32 address, mt_uint8 memtype, mt_uint8 *pdata);
#define VDSL_SET_PORT_MEM	0x7624	//mt_ret set_port_mem(mt_uint32 portid, mt_uint32 address, mt_uint8 memtype, mt_uint8 *pdata);
#define VDSL_GET_PORT_DATA	0x7625	//mt_ret get_port_data(mt_uint32 portid, mt_uint32 groupid, mt_uint32 tableid, mt_uint32 idx, mt_uint32 paramid, mt_uint32 *pvalue);
#define VDSL_SET_PORT_DATA	0x7626	//mt_ret set_port_data(mt_uint32 portid, mt_uint32 groupid, mt_uint32 tableid, mt_uint32 idx, mt_uint32 paramid, mt_uint32 value);
#define VDSL_GET_PORT_DATA_LOGIC	0x7627	//mt_ret get_port_data_logic(mt_uint32 portid, mt_uint8 *loid, mt_uint8 *strvalue);
#define VDSL_SET_PORT_DATA_LOGIC	0x7628	//mt_ret set_port_data_logic(mt_uint32 portid, mt_uint8 *loid, mt_uint8 *strvalue);
#define VDSL_GET_PORT_MEM_REMOTE	0x7629	//mt_ret get_port_mem_remote(mt_uint32 portid, mt_uint32 address, mt_uint32 length, mt_uint8 *pdata);
#define VDSL_SET_PORT_MEM_REMOTE	0x762a	//mt_ret get_port_mem_remote(mt_uint32 portid, mt_uint32 address, mt_uint32 length, mt_uint8 *pdata);
// -------------------------- Misc -----------------------
#define VDSL_SET_DEBUG_LEVEL	0x7630	//mt_ret set_debug_level(mt_uint32 lvl);
#define VDSL_WRITE_AFE_REG	0x7631	//mt_ret write_afe_reg(mt_uint32 portid, mt_uint16 offset);
#define VDSL_UPGRADE_FIRMWARE	0x7632	//mt_ret upgrade_firmware(mt_uint8 chipid, mt_uint8 cmdID, mt_uint16 bufsize, mt_uint8* buffer);
#define VDSL_RECEIVE_EOC_DATA	0x7633	//mt_ret receive_eoc_data(mt_uint8 chipid);
#define VDSL_EOC_COMMAND	0x7634	//mt_ret mt_ret eoc_command(mt_uint8 chipid, mt_uint16 bufsize, mt_uint8* buffer);
// -------------------------- Host Port Interface -----------------------
#define VDSL_WRITE_HPI_8	0x7635
#define VDSL_READ_HPI_8		0x7636
#define VDSL_ENABLE_PACING	0x7637
#define VDSL_DISABLE_PACING	0x7638
#define VDSL_GET_MIB2_HEADER	0x7639
// -------------------------- VDSL Reset -----------------------
#define VDSL_RESET	0x7640
#define VDSL_RESET_HIGH	0x7641
#define VDSL_RESET_LOW	0x7642
#define VDSL_AUTO_RESET	0x7643
#define VDSL_HPI_TEST	0x7644
#define VDSL_HPI_TEST_RD	0x7645
#define VDSL_HPI_TEST_WT	0x7646
#define VDSL_HPI_DELAY	0x7647
#define VDSL_HPI_TEST_RD_FIXSIZE	0x7648
