/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.3 $
* Date:         $Date: 2009-05-26 05:47:43 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"
/*#include "awardm.h"
#include "mttypes.h" 
#include "mterror.h"
#include "debugp.h"
#include "hdlc.h"
#include "port.h"*/

#ifdef __KERNEL__
//semaphore used to control hpi r/w
//static DECLARE_MUTEX(mr_sem_port);
#endif


void process_rcvd_frame(mt_uint32 portid, mt_uint8 *buf)
{
	if(buf[2])
		port[portid].value = (buf[7] << 16) + (buf[8] << 8) + buf[9];
	else
		PRINTL(DBG_LVL_PORT,"Port %i: Unsolicited frame\n", portid);
}

mt_uint32 send_frame_port(mt_uint32 portid, mt_uint32 len, mt_uint8 *pframe)
{
	mt_uint32 ret;
	mt_uint8 buf[MT_MAX_BUFFERSIZE];

	//down_interruptible(&mr_sem_port);

	PRINTL(DBG_LVL_PORT,"in send_frame_port:\n");	
	
	port[portid].lastcmdid++;
	if(port[portid].lastcmdid == 0)
		port[portid].lastcmdid++;
	pframe[2] = port[portid].lastcmdid;
	len = ctrl_payload_frame(buf,pframe[0],pframe[1],0,pframe+2,len-2);
	if(len)
	{
		port[portid].resprdy = 0;
		ret = send_frame_mapper(portid, len, buf);
	}
	else
	{
		ret = MT_FRAME_TOO_LONG;
	}

	//up(&mr_sem_port);

	return ret;
}

mt_uint32 handle_rx_frame_port(mt_uint32 portid, mt_uint8 *pbuf, mt_uint32 len)
{
	mt_uint32 i = len;
	mt_uint8 *ptemp = pbuf;
	
	if((i<MT_MAX_BUFFERSIZE) && ((signed int)i>0) && (debug_level & DBG_LVL_PORT))
	{
		PRINTD("Port %i: ", portid);
		while(i--)
			PRINTD("%02x ", *ptemp++);
		PRINTD("\n");
	}
	if((signed int)len > 3)
	{
		ctrl_payload_deframe(pbuf, len, &port[portid]);
		process_rcvd_frame(portid, port[portid].buf);
		port[portid].resprdy = 1;

	}
	else
	{
		if(len)
			PRINTD("Port %i: Corrupted HDLC frame!\n", portid);
		else
			PRINTD("Port %i: HDLC frame missing\n", portid);
			
		return DSL_ERR_NOTOK;
	}
	
	return MT_OK;
}

void init_system_port()
{
	int i;

	for(i=0; i<MAX_PORTS; i++)
	{
		port[i].ctrldeframestate = HDLC_FRAME_INIT;
		port[i].lastcmdid = 0;
	}
}


mt_uint32 port_resp_rdy(mt_uint32 portid)
{
	return port[portid].resprdy;
}


mt_uint32 get_port_value(mt_uint32 portid)
{
	return port[portid].value;
}


void get_port_buffer(mt_uint32 portid, mt_uint8 *pdata)
{
		pdata[0] = chips[portid].buf[F4_PEEK_CMD_OFFSET];
		pdata[1] = chips[portid].buf[F4_PEEK_CMD_OFFSET+1];
		pdata[2] = chips[portid].buf[F4_PEEK_CMD_OFFSET+2];
}


void get_port_eoc_buffer(mt_uint32 portid, mt_uint16 *count, mt_uint8 *pdata)
{
	*count=port[portid].buf[RECV_EOC_FRAME_OFFSET-1]-1;	//"-1" is used to skip EOC_EXT_MSG byte
	memcpy(pdata, port[portid].buf+RECV_EOC_FRAME_OFFSET+1, *count);	//"+1" is used to skip EOC_EXT_MSG byte
}
