/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009-03-18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#ifndef _PORT_H_
#define _PORT_H_

#define MT_MAX_BUFFERSIZE 512

typedef struct port_struct
{
	hdlc_state ctrldeframestate;
	mt_uint8 *openctrlframe;
	mt_uint16 openctrlframelen;
	mt_uint16 curfcs;
	mt_uint8 lastcmdid;
	mt_uint32 value;
	mt_uint8 resprdy;
	mt_uint8 buf[MT_MAX_BUFFERSIZE];
}port_t;


#define PEEK_CMD_OFFSET 9
#define F4_PEEK_CMD_OFFSET 3
#define RECV_EOC_FRAME_OFFSET 5

extern mt_uint32 send_frame_port(mt_uint32 portid, mt_uint32 len, mt_uint8 *pframe);
extern void init_system_port(void);
extern mt_uint32 get_port_value(mt_uint32 portid);
extern void get_port_buffer(mt_uint32 portid, mt_uint8 *pData);
extern void get_port_eoc_buffer(mt_uint32 portid, mt_uint16 *count, mt_uint8 *pdata);
extern mt_uint32 handle_rx_frame_port(mt_uint32 portid, mt_uint8 *pbuf, mt_uint32 len);

#endif	//_PORT_H_
