#ifndef _CSID_GROUPING_H_
#define _CSID_GROUPING_H_

#include "csid_gid.h"

#define _CFG_GROUPING(x)       (CSID_GIDC_GROUPING|(x))
#define _STA_GROUPING(x)       (CSID_GIDS_GROUPING|(x))

#define CSID_S_GROUPING_ALTERED       _STA_GROUPING(0x0100) //T=u8, D=0, altered

#define CSID_S_GROUPING_ADD_HOST      _STA_GROUPING(0x0101) //T=u8, D=0
#define CSID_S_GROUPING_DEL_HOST      _STA_GROUPING(0x0102) //T=u8, D=0
#define CSID_S_GROUPING_MOD_HOST      _STA_GROUPING(0x0103) //T=u8, D=0

#define CSID_S_GROUPING_ADD_FEXT      _STA_GROUPING(0x0104) //T=u8, D=0
#define CSID_S_GROUPING_DEL_FEXT      _STA_GROUPING(0x0105) //T=u8, D=0
#define CSID_S_GROUPING_MOD_FEXT      _STA_GROUPING(0x0106) //T=u8, D=0

#define CSID_S_GROUPING_ADD_APP_GRP   _STA_GROUPING(0x0107) //T=u8, D=0
#define CSID_S_GROUPING_DEL_APP_GRP   _STA_GROUPING(0x0108) //T=u8, D=0
#define CSID_S_GROUPING_MOD_APP_GRP   _STA_GROUPING(0x0109) //T=u8, D=0

//global configure
#define CSID_S_GROUPING_EANBLE                     _STA_GROUPING(0x010A) //T=u8, D=0
#define CSID_S_GROUPING_IPV6                       _STA_GROUPING(0x010B) //T=u8, D=0
                               
//host group list
#define CSID_C_GROUPING_HOST_NAME                  _CFG_GROUPING(0x1000) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_TYPE              _CFG_GROUPING(0x1020) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID1               _CFG_GROUPING(0x1040) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID2               _CFG_GROUPING(0x1060) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID3               _CFG_GROUPING(0x1080) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID4               _CFG_GROUPING(0x10A0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID5               _CFG_GROUPING(0x10C0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID6               _CFG_GROUPING(0x10E0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID7               _CFG_GROUPING(0x1100) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID8               _CFG_GROUPING(0x1120) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID9               _CFG_GROUPING(0x1140) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID10              _CFG_GROUPING(0x1160) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID11              _CFG_GROUPING(0x1180) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID12              _CFG_GROUPING(0x11A0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID13              _CFG_GROUPING(0x11C0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID14              _CFG_GROUPING(0x11E0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID15              _CFG_GROUPING(0x1200) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID16              _CFG_GROUPING(0x1220) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID17              _CFG_GROUPING(0x1240) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID18              _CFG_GROUPING(0x1260) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID19              _CFG_GROUPING(0x1280) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID20              _CFG_GROUPING(0x12A0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID21              _CFG_GROUPING(0x12C0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID22              _CFG_GROUPING(0x12E0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID23              _CFG_GROUPING(0x1300) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID24              _CFG_GROUPING(0x1320) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID25              _CFG_GROUPING(0x1340) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID26              _CFG_GROUPING(0x1360) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID27              _CFG_GROUPING(0x1380) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID28              _CFG_GROUPING(0x13A0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID29              _CFG_GROUPING(0x13C0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID30              _CFG_GROUPING(0x13E0) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID31              _CFG_GROUPING(0x1400) //T=str, D=""
#define CSID_C_GROUPING_HOST_MEM_ID32              _CFG_GROUPING(0x1420) //T=str, D=""
#define CSID_C_GROUPING_HOST_BOUND_FIREWALL        _CFG_GROUPING(0x1440) //T=u8, D=0
#define CSID_C_GROUPING_HOST_BOUND_QOS             _CFG_GROUPING(0x1460) //T=u8, D=0
#define CSID_C_GROUPING_HOST_EANBLE                _CFG_GROUPING(0x1480) //T=u8, D=1

//add host group
#define CSID_C_GROUPING_HOST_ADD_NAME                  _CFG_GROUPING(0x2000) //T=str, D=""
#define CSID_C_GROUPING_HOST_ADD_MEM_TYPE              _CFG_GROUPING(0x2001) //T=str, D=""
#define CSID_C_GROUPING_HOST_ADD_MEM_ID                _CFG_GROUPING(0x2010) //T=str, D=""
#define CSID_C_GROUPING_HOST_ADD_BOUND_FIREWALL        _CFG_GROUPING(0x2030) //T=u8, D=0
#define CSID_C_GROUPING_HOST_ADD_BOUND_QOS             _CFG_GROUPING(0x2031) //T=u8, D=0
#define CSID_C_GROUPING_HOST_ADD_EANBLE                _CFG_GROUPING(0x2032) //T=u8, D=1

//delete host group
#define CSID_C_GROUPING_HOST_DEL_NAME                  _CFG_GROUPING(0x2033) //T=str, D=""

//edit host group
#define CSID_C_GROUPING_HOST_MOD_ORG_NAME              _CFG_GROUPING(0x3000) //T=str, D=""
#define CSID_C_GROUPING_HOST_MOD_NAME                  _CFG_GROUPING(0x3001) //T=str, D=""
#define CSID_C_GROUPING_HOST_MOD_MEM_TYPE              _CFG_GROUPING(0x3002) //T=str, D=""
#define CSID_C_GROUPING_HOST_MOD_MEM_ID                _CFG_GROUPING(0x3010) //T=str, D=""
#define CSID_C_GROUPING_HOST_MOD_BOUND_FIREWALL        _CFG_GROUPING(0x3030) //T=u8, D=0
#define CSID_C_GROUPING_HOST_MOD_BOUND_QOS             _CFG_GROUPING(0x3031) //T=u8, D=0
#define CSID_C_GROUPING_HOST_MOD_EANBLE                _CFG_GROUPING(0x3032) //T=u8, D=0

//---------------------------------------------------------------------
//file extension list
#define CSID_C_GROUPING_FEXT_NAME                  _CFG_GROUPING(0x4000) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FILE_TYPE             _CFG_GROUPING(0x4020) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT1               _CFG_GROUPING(0x4040) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT2               _CFG_GROUPING(0x4060) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT3               _CFG_GROUPING(0x4080) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT4               _CFG_GROUPING(0x40A0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT5               _CFG_GROUPING(0x40C0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT6               _CFG_GROUPING(0x40E0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT7               _CFG_GROUPING(0x4100) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT8               _CFG_GROUPING(0x4120) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT9               _CFG_GROUPING(0x4140) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT10              _CFG_GROUPING(0x4160) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT11              _CFG_GROUPING(0x4180) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT12              _CFG_GROUPING(0x41A0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT13              _CFG_GROUPING(0x41C0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT14              _CFG_GROUPING(0x41E0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT15              _CFG_GROUPING(0x4200) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT16              _CFG_GROUPING(0x4220) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT17              _CFG_GROUPING(0x4240) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT18              _CFG_GROUPING(0x4260) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT19              _CFG_GROUPING(0x4280) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT20              _CFG_GROUPING(0x42A0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT21              _CFG_GROUPING(0x42C0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT22              _CFG_GROUPING(0x42E0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT23              _CFG_GROUPING(0x4300) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT24              _CFG_GROUPING(0x4320) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT25              _CFG_GROUPING(0x4340) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT26              _CFG_GROUPING(0x4360) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT27              _CFG_GROUPING(0x4380) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT28              _CFG_GROUPING(0x43A0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT29              _CFG_GROUPING(0x43C0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT30              _CFG_GROUPING(0x43E0) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT31              _CFG_GROUPING(0x4400) //T=str, D=""
#define CSID_C_GROUPING_FEXT_FORMAT32              _CFG_GROUPING(0x4420) //T=str, D=""
#define CSID_C_GROUPING_FEXT_BOUND_FIREWALL        _CFG_GROUPING(0x4440) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_BOUND_QOS             _CFG_GROUPING(0x4460) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_EANBLE                _CFG_GROUPING(0x4480) //T=u8, D=0

//add file ext group
#define CSID_C_GROUPING_FEXT_ADD_NAME                  _CFG_GROUPING(0x5000) //T=str, D=""
#define CSID_C_GROUPING_FEXT_ADD_FILE_TYPE             _CFG_GROUPING(0x5001) //T=str, D=""
#define CSID_C_GROUPING_FEXT_ADD_FORMAT                _CFG_GROUPING(0x5010) //T=str, D=""
#define CSID_C_GROUPING_FEXT_ADD_BOUND_FIREWALL        _CFG_GROUPING(0x5030) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_ADD_BOUND_QOS             _CFG_GROUPING(0x5031) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_ADD_EANBLE                _CFG_GROUPING(0x5032) //T=u8, D=1

//delete file ext group
#define CSID_C_GROUPING_FEXT_DEL_NAME                  _CFG_GROUPING(0x5033) //T=str, D=""

//edit file ext group
#define CSID_C_GROUPING_FEXT_MOD_ORG_NAME              _CFG_GROUPING(0x6000) //T=str, D=""
#define CSID_C_GROUPING_FEXT_MOD_NAME                  _CFG_GROUPING(0x6001) //T=str, D=""
#define CSID_C_GROUPING_FEXT_MOD_FILE_TYPE             _CFG_GROUPING(0x6002) //T=str, D=""
#define CSID_C_GROUPING_FEXT_MOD_FORMAT                _CFG_GROUPING(0x6010) //T=str, D=""
#define CSID_C_GROUPING_FEXT_MOD_BOUND_FIREWALL        _CFG_GROUPING(0x6030) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_MOD_BOUND_QOS             _CFG_GROUPING(0x6031) //T=u8, D=0
#define CSID_C_GROUPING_FEXT_MOD_EANBLE                _CFG_GROUPING(0x6032) //T=u8, D=0
//-----------------------------------------------------------------------
//application list
#define CSID_C_GROUPING_APP_GRP_NAME               _CFG_GROUPING(0x7000) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_TYPE               _CFG_GROUPING(0x7020) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME1          _CFG_GROUPING(0x7040) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME2          _CFG_GROUPING(0x7060) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME3          _CFG_GROUPING(0x7080) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME4          _CFG_GROUPING(0x70A0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME5          _CFG_GROUPING(0x70C0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME6          _CFG_GROUPING(0x70E0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME7          _CFG_GROUPING(0x7100) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME8          _CFG_GROUPING(0x7120) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME9          _CFG_GROUPING(0x7140) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME10         _CFG_GROUPING(0x7160) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME11         _CFG_GROUPING(0x7180) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME12         _CFG_GROUPING(0x71A0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME13         _CFG_GROUPING(0x71C0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME14         _CFG_GROUPING(0x71E0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME15         _CFG_GROUPING(0x7200) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME16         _CFG_GROUPING(0x7220) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME17         _CFG_GROUPING(0x7240) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME18         _CFG_GROUPING(0x7260) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME19         _CFG_GROUPING(0x7280) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME20         _CFG_GROUPING(0x72A0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME21         _CFG_GROUPING(0x72C0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME22         _CFG_GROUPING(0x72E0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME23         _CFG_GROUPING(0x7300) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME24         _CFG_GROUPING(0x7320) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME25         _CFG_GROUPING(0x7340) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME26         _CFG_GROUPING(0x7360) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME27         _CFG_GROUPING(0x7380) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME28         _CFG_GROUPING(0x73A0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME29         _CFG_GROUPING(0x73C0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME30         _CFG_GROUPING(0x73E0) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME31         _CFG_GROUPING(0x7400) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_APP_NAME32         _CFG_GROUPING(0x7420) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_BOUND_FIREWALL     _CFG_GROUPING(0x7440) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_BOUND_QOS          _CFG_GROUPING(0x7460) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_EANBLE             _CFG_GROUPING(0x7480) //T=u8, D=0

//add application group
#define CSID_C_GROUPING_APP_GRP_ADD_NAME               _CFG_GROUPING(0x8000) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_ADD_TYPE               _CFG_GROUPING(0x8001) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_ADD_APP_NAME           _CFG_GROUPING(0x8010) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_ADD_BOUND_FIREWALL     _CFG_GROUPING(0x8030) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_ADD_BOUND_QOS          _CFG_GROUPING(0x8031) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_ADD_EANBLE             _CFG_GROUPING(0x8032) //T=u8, D=1

//delete application group
#define CSID_C_GROUPING_APP_GRP_DEL_NAME               _CFG_GROUPING(0x8033) //T=str, D=""

//edit application group
#define CSID_C_GROUPING_APP_GRP_MOD_ORG_NAME           _CFG_GROUPING(0x9000) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_MOD_NAME               _CFG_GROUPING(0x9001) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_MOD_TYPE               _CFG_GROUPING(0x9002) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_MOD_APP_NAME           _CFG_GROUPING(0x9010) //T=str, D=""
#define CSID_C_GROUPING_APP_GRP_MOD_BOUND_FIREWALL     _CFG_GROUPING(0x9030) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_MOD_BOUND_QOS          _CFG_GROUPING(0x9031) //T=u8, D=0
#define CSID_C_GROUPING_APP_GRP_MOD_EANBLE             _CFG_GROUPING(0x9032) //T=u8, D=0


#endif
