#ifndef _CSID_RADIUS_USER_H_
#define _CSID_RADIUS_USER_H_

#include "csid_gid.h"

#define _CFG_RADIUS_USER(x)       (CSID_GIDC_RADIUS_USER|(x))
#define _STA_RADIUS_USER(x)       (CSID_GIDS_RADIUS_USER|(x))

#define CSID_S_RADIUS_USER_ALTERED  _STA_RADIUS_USER(0x0100) //T=u8, D=0, altered
//used to trigger ALTERED
#define CSID_S_RADIUS_ADD_USER      _STA_RADIUS_USER(0x0101) //T=u8, D=0
#define CSID_S_RADIUS_DEL_USER      _STA_RADIUS_USER(0x0102) //T=u8, D=0
#define CSID_S_RADIUS_MOD_USER      _STA_RADIUS_USER(0x0103) //T=u8, D=0
#define CSID_C_RADIUS_USER_LIST     _CFG_RADIUS_USER(0x0104) //T=u8, D=0

//add user
#define CSID_C_RADIUS_ADD_USER_NAME        _CFG_RADIUS_USER(0x1000) //T=str, D=""
#define CSID_C_RADIUS_ADD_USER_PASSWD      _CFG_RADIUS_USER(0x1001) //T=str, D=""
#define CSID_C_RADIUS_ADD_USER_LEVEL       _CFG_RADIUS_USER(0x1002) //T=u8, D=0
#define CSID_C_RADIUS_ADD_USER_LEASETIME   _CFG_RADIUS_USER(0x1003) //T=str, D=""
#define CSID_C_RADIUS_ADD_USER_IDLETIMEOUT _CFG_RADIUS_USER(0x1004) //T=str, D=""
#define CSID_C_RADIUS_ADD_USER_GROUPTO     _CFG_RADIUS_USER(0x1005) //T=str, D=""
#define CSID_C_RADIUS_ADD_USER_ENABLE      _CFG_RADIUS_USER(0x1006) //T=u8, D=1
#define CSID_S_RADIUS_ADD_USER_COMPLETE    _STA_RADIUS_USER(0x1007) //T=u8, D=0

//delete user
#define CSID_C_DEL_USER_NAME        _CFG_RADIUS_USER(0x2000) //T=str, D=""
#define CSID_S_DEL_USER_COMPLETE    _STA_RADIUS_USER(0x2101) //T=u8, D=0

//modify user
#define CSID_C_MOD_USER_NAME_ORG    _CFG_RADIUS_USER(0x3000)  //T=str, D=""
#define CSID_C_MOD_USER_NAME        _CFG_RADIUS_USER(0x3001)  //T=str, D=""
#define CSID_C_MOD_USER_PASSWD      _CFG_RADIUS_USER(0x3002)  //T=str, D=""
#define CSID_C_MOD_USER_LEVEL       _CFG_RADIUS_USER(0x3003)  //T=u8, D=0
#define CSID_C_MOD_USER_LEASETIME   _CFG_RADIUS_USER(0x3004)  //T=str, D=""
#define CSID_C_MOD_USER_IDLETIMEOUT _CFG_RADIUS_USER(0x3005)  //T=str, D=""
#define CSID_C_MOD_USER_GROUPTO     _CFG_RADIUS_USER(0x3006)  //T=str, D=""
#define CSID_C_MOD_USER_ENABLE      _CFG_RADIUS_USER(0x3007)  //T=u8, D=0
#define CSID_S_MOD_USER_COMPLETE    _STA_RADIUS_USER(0x3108)  //T=u8, D=0

//database to store informations of users
#define BEGIN_USERNAME       0x4000
#define BEGIN_PASSWD         0x4200
#define BEGIN_ENABLED        0x4400
#define BEGIN_LEVLE          0x4600
#define BEGIN_LEASETIME      0x4800
#define BEGIN_IDLETIMEOUT    0x4A00
#define BEGIN_GROUPTO        0x4C00
#define BEGIN_IP	     0x4E00	
#define BEGIN_STATUS	     0x5000
#define BEGIN_EXPIRE	     0x5200
#define BEGIN_IDLE_TIME      0x5400
#define BEGIN_LAST_LOGIN_TIME 0x5600


#define CSID_C_RADIUS_USER              _CFG_RADIUS_USER(0x4000) //T=str, D="" ,user name
#define CSID_C_RADIUS_PASSWD            _CFG_RADIUS_USER(0x4200)  //T=str, D="" , user password
#define CSID_C_RADIUS_LEVEL             _CFG_RADIUS_USER(0x4600)  //T=u8, D=0
#define CSID_C_RADIUS_LEASETIME         _CFG_RADIUS_USER(0x4800)  //T=str, D=""
#define CSID_C_RADIUS_IDLETIMEOUT       _CFG_RADIUS_USER(0x4A00)  //T=str, D=""
#define CSID_C_RADIUS_GROUPTO           _CFG_RADIUS_USER(0x4C00)  //T=str, D="" 
#define CSID_C_RADIUS_USER_ENABLE       _CFG_RADIUS_USER(0x4400)  //T=u8, D=0, enable flag 
#define CSID_C_RADIUS_USER_IP           _CFG_RADIUS_USER(0x4E00)       //T=str, D="" ,ip address
#define CSID_C_RADIUS_USER_STATUS       _CFG_RADIUS_USER(0x5000)   //T=u8, D=0 ,online or not
#define CSID_C_RADIUS_USER_EXPIRE       _CFG_RADIUS_USER(0x5200)   //T=str, D="" ,expire time
#define CSID_C_RADIUS_USER_IDLE_TIME    _CFG_RADIUS_USER(0x5400) //T=str, D="" ,idle time
#define CSID_C_RADIUS_LAST_LOGIN_TIME   _CFG_RADIUS_USER(0x5600) //T=str, D="" , last login time

#endif
